<!--
SPDX-FileCopyrightText: 2023 Bundesministerium des Innern und für Heimat, PG ZenDiS "Projektgruppe für Aufbau ZenDiS"
SPDX-License-Identifier: Apache-2.0
-->
**Content / Quick navigation**

[[_TOC_]]

# openDesk base - cluster-level dependencies

Preparing a Kubernetes cluster with all requirements to run a full
[openDesk](https://gitlab.opencode.de/bmi/souveraener_arbeitsplatz/deployment/sovereign-workplace) deployment can be a
time-consuming task.

This repository helps bootstrapping a (vanilla) Kubernetes cluster with the cluster-level requirements. It is the same
deployment that is used in the development of openDesk on bare-metal infrastructure (Proxmox + kubespray) and for
cloud providers offering a managed Kubernetes serivce.

**Note: This repository is just a helping hand for those who seek it. It's not part of openDesk and we do not provide
any support. So MRs and issues might receive no response.**

## Componentes

To prepare a cluster, you need various cluster/cloud-specific tools, some of them are optional or only required for
extended functionality, e.g. deploying multiple openDesk installations into a single cluster and getting emails routed
into the installations with having just a single Postfix listening on a public IP's port 25 for the cluster.

### Vanilla cluster base components

While all major cloud providers come already pre-configured with volume provisioner and a CNI for your vanilla K8s cluster you have to take care of their installation. We prefer [cilium](https://github.com/cilium/cilium) as CNI and [ceph](https://github.com/ceph/ceph-csi) as volume provisioner.

This deployment repository provides configuration for:
- ceph
- cilium

### openDesk components

To use the full potential of the openDesk's deployment automation, you need some components and CRDs on a cluster level.

This deployment repository provides configuration for:
- cert-manager
- clamav
- coturn
- istio
- nginx-ingress
- postfix

### optional components

Enhancing the deployment or preparing for future features, the deployment contains configuration for:
- gateway-api
- gitlab-runner
- kube-prometheus-stack
- kyverno

## usage

Custom parametrization can be done in `helmfile/environments/dev/values.yaml`.

### Enable/disable components

To check what components are enabled/disabled by default please check the [workplace.yaml](./helmfile/environments/default/workplace.yaml).

### Environment variables

Environment variables are used/required by some components:

| name                           | default                               | component | description                                       |
|--------------------------------|---------------------------------------|-----------|---------------------------------------------------|
| `DOMAIN`                       | `open-desk.cloud`                     |           | External reachable domain                         |
| `MASTER_PASSWORD`              | `opendesk`                            |           | The password that seeds the autogenerated secrets |
| `TURN_CREDENTIALS`             |                                       | `coturn`  | Credentials for coturn server                     |
| `GITLAB_URL`                   | `https://gitlab.souvap-univention.de` | `gitlab`  | Gitlab URI to register runner                     |
| `GITLAB_RUNNER_TOKEN`          |                                       | `gitlab`  | Gitlab runner token                               |
| `CEPH_SECRET_CEPHFS_ADMIN_KEY` |                                       | `ceph`    | Cephfs admin key                                  |
| `CEPH_SECRET_RBD_USER_KEY`     |                                       | `ceph`    | Ceph RBD user key                                 |

### Local registries

It is possible to use your own registry for helm charts and container images by setting these environment variables:

| name                         | description                    |
|------------------------------|--------------------------------|
| PRIVATE_CHART_REPOSITORY_URL | Your helm chart repository url |
| PRIVATE_IMAGE_REGISTRY_URL   | Your image registry url        |


### Deployment

```shell
helmfile apply
```

with custom settings:

```shell
helmfile apply -e dev
```

## Compontents

More detailled information on selected components can be found in this section.

### Kyverno

[Kyverno](https://kyverno.io/) is a policy engine for K8s to find potential security issues based on a given set of policies.

Kyverno deployment is a singleton within the cluster and is not exposed through an Ingress resource. In order to access the Kyverno UI create a tunnel by running:

```
kubectl -n kyverno port-forward svc/policy-reporter-ui 8080:8080
```

Once the tunnel is up and running you access the UI through http://localhost:8080 

You might want navigate into `Policy Reports`, select your namespace and set the `Kinds` filter to `Pod` and `Job` to avoid doublettes being rendered for `StatefulSets`.

Apply other filters as you need them, e.g. to check what components are missing liveness and/or readiness probes select `require-health-and-liveness-check` on the `Policies` filter.

## License

This project uses the following license: Apache-2.0

## Copyright

Copyright © 2023 Bundesministerium des Innern und für Heimat, PG ZenDiS "Projektgruppe für Aufbau ZenDiS"
